#portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # V2.0
  
  require 'sketchup.rb'

  #creates dado in component face
 class DadoTool #*****************************************************************
   #@status=0 start,  =1 select component, =2 first edge, =3 second edge
   
   @@todist=nil   #make class variables persist
   @@toedge=nil
   @@depth=nil  
   @@width=nil
   

  def initialize
   @entity=nil
   @ss=nil
   @status=0
   @inpt=nil
   @tinpt=nil
   @ip=nil
   if !@@todist then @@todist=0.25.inch end           #defaults
   if !@@toedge then @@toedge="To" end
   if !@@depth then @@depth=0.25.inch end                  
   if !@@width then @@width=0.75.inch end
  end

  #is called when first activated
  def activate
   @inpt = Sketchup::InputPoint.new           #set up Input point and temp and diplayed
   @tinpt= Sketchup::InputPoint.new
   @ip= Sketchup::InputPoint.new
   #@displayed = false

   #lets see if any componenent is already selected
   model=Sketchup.active_model
   @ss=model.selection
   le=@ss.count   

   self.reset(nil)
  
   @status=0
   oops=0
   if le==1
    @entity=@ss.first
    type=@entity.typename
    if type=="ComponentInstance"
     Sketchup::set_status_text "Select FROM edge in component",SB_PROMPT
     @status=2
    else
     oops=1
    end
   elsif le>=1
    oops=1
   else                      #nothing selected
    @status=1
   end
   
   if oops==1
    UI.messagebox "Selection invalid"
    @ss.clear
    @entity=nil
    @status=1
   end
  end
  
  #is called if tool is deactivated because a different tool is selected
  def deactivate(view)
   view.invalidate 
  end

  #onCancel is called when user hits escape etc
  def onCancel(flag, view)
    if (flag==2)
     view.invalidate
    else
     self.reset(view)
    end
  end

 #reset to start over again
  def reset(view)
   @status=1
   @displayed=false
   @entity=nil
     Sketchup::set_status_text "Select component",SB_PROMPT
  end

   #cruise for a point in component
  def onMouseMove(flags, x, y, view)
   if (@status==2 or @status==3)
    @tinpt.pick view, x, y
    if (@tinpt.valid?) 
      changed=@tinpt != @inpt
      @inpt.copy! @tinpt 
      view.tooltip = @tinpt.tooltip
      #display point
      if ( changed and (@inpt.display? or @displayed))
       view.invalidate 
      end
    end
   end
  end

  #get a point
  def onLButtonDown(flags, x, y, view)
    if @status==1  #select component*************
     ph=view.pick_helper
     ph.do_pick x,y
     @entity=ph.best_picked
     if @entity
      type=@entity.typename
      if type=="ComponentInstance"
       model=Sketchup.active_model
       @ss=model.selection
       @ss.add(@entity)
        Sketchup::set_status_text "Select FROM edge in component",SB_PROMPT
        @status=2
      else
       UI.messagebox "Selection invalid"
      end
     end
    elsif @status==2
	 @ip.pick view,x,y
	 oops=1
     if(@ip.valid?)
	  if(@ip.edge)
	   if (@entity.definition==@ip.edge.parent)
	    if ((!@ip.vertex) and (@ip.depth>0))
		 oops=0
		 @edge1=@ip.edge
	     Sketchup::set_status_text "Select TO edge in component",SB_PROMPT
         @status=3
		end 
	   end	
	  end 
	 end
	 if oops==1
	  @status=2
	  @edge1=nil
	  UI.messagebox "Invalid point"
	 end
	elsif @status==3
	 @ip.pick view,x,y
     oops=1
     if(@ip.valid?)
	  if(@ip.edge)
	   if (@entity.definition==@ip.edge.parent)
	    if ((!@ip.vertex) and !(@ip.edge==@edge1) and (@ip.depth>0))
		 oops=0
		 Sketchup.active_model.start_operation "undo"
		 @edge2=@ip.edge
		 #collectentities
            componentdefinition=@entity.definition
            allent=componentdefinition.entities
            #collect face entities
            faceent=[]
            allent.each do |ent|
             if ent.typename=="Face"
              faceent << ent
             end
            end
		    #find face that has edges 1 and 2
			face=@edge1.common_face @edge2
			if (face==nil)                    #get valid face
		     oops=1
			else                              #got valid face######################
			   #get points in local coord system for face
			   #xaxis parallel to @edge1
			   orig=@edge1.start
               x,y,z=face.normal.axes
			   #get vector parallel to @edge1
			   p1=@edge1.start.position
			   p2=@edge1.end.position
			   ar=[p2.x-p1.x,p2.y-p1.y,p2.z-p1.z]
			   xx=ar.normalize
			   yy=z.cross xx
               localt=Geom::Transformation.axes(orig,xx,yy,z).invert!
			   backt=Geom::Transformation.axes(orig,xx,yy,z)
			   edges=face.outer_loop.edges
			   eind=edges.index(@edge1)
			   
			   prompts = ["To Distance","To Edge", "Width","Depth"]
               defaults= [@@todist,@@toedge,@@width,@@depth]
               choices = ["","To|Center|Over","",""]
   
               results = inputbox prompts, defaults, choices, "Dado Board"
               #return if not results
			   if not results  #user cancel
			    @status=2
			    @edge1=nil
			    @edge2=nil
			    return
			   end
  
               @@todist=results[0]
               @@toedge=results[1]
               @@width=results[2]
               @@depth=results[3]
			   
			   if @@toedge=="To"
			    ofstov=@@todist+@@width
			   elsif @@toedge=="Center"
			    ofstov=@@todist+0.5*@@width
			   else 
			    ofstov=@@todist
			   end
			   ofstto=ofstov-@@width
			   if ofstto<=0.001 then ofstto=0 end
			   
               #looppts=loop.vertices.collect{|v| v.position.transform(localt)}
			   p3=@edge2.start.position.transform(localt)
			   en=eind-edges.length+1;i=eind-1
			   dir=p3.y<=>0 
			   ofstov=dir*ofstov
			   ofstto=dir*ofstto
			   frstov=0
			   frstto=0
			   while i>=en
			    p1=edges[i].start.position.transform(localt)
                p2=edges[i].end.position.transform(localt)
                p1y=p1.y;p2y=p2.y
				if p1y>p2y then p1y,p2y=p2y,p1y end
                if (p1y..p2y)===ofstov
				 x=p1.x+(ofstov-p1.y)/(p2.y-p1.y)*(p2.x-p1.x)
				 if frstov==0 then x1=x;frstov=1 end
				 x2=x
                end	
				if ofstto.abs>0.001
				 if (p1y..p2y)===ofstto
				  x=p1.x+(ofstto-p1.y)/(p2.y-p1.y)*(p2.x-p1.x)
				  if frstto==0 then x4=x;frstto=1 end
				  x3=x
				 end
				end
			    i-=1
			   end
			   pt1=Geom::Point3d.new(x1,ofstov,0)
			   pt2=Geom::Point3d.new(x2,ofstov,0)
			   if ofstto.abs>0.001
			    pt4=Geom::Point3d.new(x4,ofstto,0)
			    pt3=Geom::Point3d.new(x3,ofstto,0)
			   else
			    pt4=Geom::Point3d.new(x1,0,0)
			    pt3=Geom::Point3d.new(x2,0,0)
			   end
			   po1=pt1.transform(backt)
			   po4=pt4.transform(backt)
			   po2=pt2.transform(backt)
			   po3=pt3.transform(backt)
			   codef=@entity.definition
			   cface=codef.entities.add_face po1,po2,po3,po4

		     h=-1*@@depth	   
             cface.pushpull h
             Sketchup.active_model.commit_operation
			  
		     Sketchup::set_status_text "Select FROM edge in component",SB_PROMPT
             @status=2
		    end                                ####################################
		end 
	   end	
	  end 
	 end
     if oops==1
	  @status=3
	  @edge2=nil
	  UI.messagebox "Invalid point"
	 end	  
    end
  end  

  #draw is called when we want to display then point
  def draw(view)
   if( @inpt.valid? and @inpt.display? )
    @inpt.draw view
    @displayed=true
   else
    @displayed=false
   end
  end

  
 end #end Class DadoTool*********************************************

 #function acts as short cut for selecting tool
 def dadoboard
   Sketchup.active_model.select_tool DadoTool.new
 end

 if( not file_loaded?("DadoBoard.rb"))
  UI.menu("Draw").add_item("Dado Board"){dadoboard}
 end

 file_loaded("DadoBoard.rb")
#--------------------------