#portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # V2.0
  
  require 'sketchup.rb'
  
  #drills hole in component face
 class DrillTool #*****************************************************************
  #@status=0 start,  =1 select component, =2 component selected get point
   @@depth=nil  #make class variables persist
   @@diam=nil
   @@nseg=nil

  def initialize
   @entity=nil
   @ss=nil
   @status=0
   @inpt=nil
   @tinpt=nil
   @ip=nil
   if !@@depth then @@depth=99.inch end                 #defaults 
   if !@@diam then @@diam=0.375.inch end
   if !@@nseg then @@nseg=8 end
  end

  #is called when first activated
  def activate
   @inpt = Sketchup::InputPoint.new           #set up Input point and temp and diplayed
   @tinpt= Sketchup::InputPoint.new
   @ip= Sketchup::InputPoint.new
   #@displayed = false

   #lets see if any componenent is already selected
   model=Sketchup.active_model
   @ss=model.selection
   le=@ss.count   

   self.reset(nil)
  
   @status=0
   oops=0
   if le==1
    @entity=@ss.first
    type=@entity.typename
    if type=="ComponentInstance"
     Sketchup::set_status_text "Select point on face in component",SB_PROMPT
     @status=2
    else
     oops=1
    end
   elsif le>=1
    oops=1
   else                      #nothing selected
    @status=1
   end
   
   if oops==1
    UI.messagebox "Selection invalid"
    @ss.clear
    @entity=nil
    @status=1
   end
  end

  #is called if tool is deactivated because a different tool is selected
  def deactivate(view)
   view.invalidate 
  end

  #onCancel is called when user hits escape etc
  def onCancel(flag, view)
    if (flag==2)
     view.invalidate
    else
     self.reset(view)
    end
  end

  #reset to start over again
  def reset(view)
   @status=1
   @displayed=false
   @entity=nil
     Sketchup::set_status_text "Select component",SB_PROMPT
  end

  #cruise for a point in component
  def onMouseMove(flags, x, y, view)
   if @status==2
    @tinpt.pick view, x, y
    if (@tinpt.valid?) 
      changed=@tinpt != @inpt
      @inpt.copy! @tinpt 
      view.tooltip = @tinpt.tooltip
      #display point
      if ( changed and (@inpt.display? or @displayed))
       view.invalidate 
      end
    end
   end
  end

  #get a point
  def onLButtonDown(flags, x, y, view)
    if @status==1  #select component*************
     ph=view.pick_helper
     ph.do_pick x,y
     @entity=ph.best_picked
     if @entity
      type=@entity.typename
      if type=="ComponentInstance"
       model=Sketchup.active_model
       @ss=model.selection
       @ss.add(@entity)
        Sketchup::set_status_text "Select point on face in component",SB_PROMPT
        @status=2
      else
       UI.messagebox "Selection invalid"
      end
     end
    elsif @status==2     #get valid center point for circle
     @ip.pick view,x,y
     oops=1
     if(@ip.valid?)
      if(@ip.face)then
       if (@entity.definition==@ip.face.parent) 
         if ((!@ip.vertex) and (!@ip.edge) and (@ip.depth>0))
           Sketchup.active_model.start_operation "undo"
           oops=0
           #collectentities
            componentdefinition=@entity.definition
            allent=componentdefinition.entities
            #collect face entities
            faceent=[]
            allent.each do |ent|
             if ent.typename=="Face"
              faceent << ent
             end
            end

           tran=@entity.transformation.inverse
           norm=@ip.face.normal
           plane=@ip.face.plane
           pos=@ip.position.transform! tran    #oddly pos yields world coord to transform 
                                               #to inverse of component transformation
           line = [pos,norm]                   #component space
           
           num=0                               #get perp to this face - dist to other face
           dist=10000
           faceent.each do |ent|
            eplane=ent.plane
             if !(eplane==plane)
              npt=Geom.intersect_line_plane(line,eplane)
              if !(npt==nil)                   #npt is perp point in someother plane
               orig=ent.vertices[0].position
               x,y,z=ent.normal.axes
               localt=Geom::Transformation.axes(orig,x,y,z).invert!
               loop=ent.outer_loop
               tnpt=npt.transform(localt)
               looppts=loop.vertices.collect{|v| v.position.transform(localt)}
               bounds=false
               youin=Geom.point_in_polygon_2D(tnpt,looppts,bounds)
               if youin
                 dd=((pos.x-npt.x)**2+(pos.y-npt.y)**2+(pos.z-npt.z)**2)**0.5
                 if ((dd>=0.01) and (dd<dist)) then dist=dd end
               end
              end
             end
           end                                #got perpdist to other face
		   
			prompts = ["Diameter","Depth", "Number segments"]
			defaults= [@@diam.inch,@@depth.inch,@@nseg]
			results = inputbox prompts, defaults, "Drill Board"
			if !results then return end  #user canceled
			@@diam=results[0]
			@@depth=results[1]
			@@nseg=results[2]
			if @@diam<0.1 then return end
			if @@depth==0 then return end
			if @@nseg<4 then @nseg=4 end
			      
           r=0.5*@@diam    
           codef=@entity.definition                           
           circ=codef.entities.add_circle(pos,norm,r,@@nseg)
           l=codef.entities.length-1
           cface=codef.entities[l]  
                                         #apparently positive pushpull is always out?
           if (@@depth>dist)
		    h=-1*dist
           else
		    h=-1*@@depth
           end		   
           cface.pushpull h
           Sketchup.active_model.commit_operation
         end
       end
      end
     end
     if oops==1
      UI.messagebox "Invalid point"
     end
    end
  end  

  #draw is called when we want to display then point
  def draw(view)
   if( @inpt.valid? and @inpt.display? )
    @inpt.draw view
    @displayed=true
   else
    @displayed=false
   end
  end

  
 end #end Class DrillTool************************************

 #function acts as short cut for selecting tool
 def drillboard
   Sketchup.active_model.select_tool DrillTool.new
 end

 if( not file_loaded?("DrillBoard.rb"))
  UI.menu("Draw").add_item("Drill Board"){drillboard}
 end

 file_loaded("DrillBoard.rb")
 
 