#portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # V2.0
  
  require 'sketchup.rb'

  
  #Resize a rectalinear component, only has meaning for rectalinear component
 # rejects multiple parallel faces etc.
 class ResizeBoard #*****************************************************************

  def initialize
   @entity=nil
   @ss=nil
  end
  
  #is called when first activated
  def activate
 
   #lets see if any componenent is already selected
   model=Sketchup.active_model
   @ss=model.selection
   le=@ss.count   

   self.reset(nil)
  
   @status=0
   oops=0
   if le==1
    @entity=@ss.first
    type=@entity.typename
    if type=="ComponentInstance"
     actonfaces
     self.reset(nil)
    else
     oops=1
    end
   elsif le>=1
    oops=1
   else                      #nothing selected
    @status=1
   end
   
   if oops==1
    UI.messagebox "Selection invalid"
    @ss.clear
    @entity=nil
    @status=1
   end
   
  end

  #is called if tool is deactivated because a different tool is selected
  #not necessary I guess here
  #def deactivate(view)
  # view.invalidate if @drawn
  #end

  #onCancel is called when user hits escape
  def onCancel(flag, view)
   self.reset(view)
  end

  #get a point
  def onLButtonDown(flags, x, y, view)
    if @status==1
     ph=view.pick_helper
     ph.do_pick x,y
     @entity=ph.best_picked
     if @entity
      type=@entity.typename
      if type=="ComponentInstance"
       model=Sketchup.active_model
       @ss=model.selection
       @ss.add(@entity)
       actonfaces
      else
       UI.messagebox "Selection invalid"
      end
     end
    end
  end
  
  def actonfaces  #collect faces, gets valid rectilinear faces and distance
                  #input new distance and edit component
   pface1=nil;dist1=10000
   pface2=nil;dist2=10000
   pface3=nil;dist3=10000
   #collectentities
   componentdefinition=@entity.definition
   allent=componentdefinition.entities
   #collect face entities
   faceent=[]
   faceentdid=[]
   allent.each do |ent|
    if ent.typename=="Face"
     faceent << ent
     faceentdid <<0
    end
   end
   
   num=0    #of valid distances between faces
   j=0
   faceent.each do |ent|
    if faceentdid[j]==0
     pface,dist = getparallelface(ent,faceent)
     cnorm=ent.normal
     k=0
     faceent.each do |lent|
       if cnorm.parallel?(lent.normal)
        faceentdid[k]=1
       end
      k=k+1
     end
    else
     pface=nil
     dist=0
    end    
    
    if dist>0 then 
     num=num+1
     if num==1 then pface1=pface;dist1=dist end
     if num==2 then pface2=pface;dist2=dist end
     if num==3 then pface3=pface;dist3=dist end
    end  
    j=j+1
   end 

   if (dist1+dist2+dist3)==30000 then
    @ss.clear
    return
   end

   #sort for input box
   if dist1>dist2 then pface1,pface2=pface2,pface1;dist1,dist2=dist2,dist1 end
   if dist2>dist3 then pface2,pface3=pface3,pface2;dist2,dist3=dist3,dist2 end
   if dist1>dist2 then pface1,pface2=pface2,pface1;dist1,dist2=dist2,dist1 end
   prompts = ["1st Dim","2nd Dim", "3rd Dim"]
   defaults= [dist1.to_l,dist2.to_l,dist3.to_l]
   
   results = inputbox prompts, defaults, "Resize Board"
   
   if !results then   #user canceled
    @ss.clear
    return
   end
   
   #push pull
   Sketchup.active_model.start_operation "undo"
   if (dist1<9999) and (dist1>0.01)
    zd= results[0]-dist1
    if zd.abs>0.01 then
      pface1.pushpull zd
    end
   end
   if (dist2<9999) and (dist2>0.01)
    zd= results[1]-dist2
    if zd.abs>0.01 then
      pface2.pushpull zd
    end
   end
   if (dist3<9999) and (dist3>0.01)
    zd= results[2]-dist3
    if zd.abs>0.01 then
      pface3.pushpull zd
    end
   end
   @ss.clear
   Sketchup.active_model.commit_operation
  end        #end actonfaces
  
  #get farthest parallel face and distance from face to facent[]
  #we subtract the actual normal vectors to eliminate origin problems
  #and get the distance between parallel planes
  def getparallelface(face,faceent)
   dist=0
   pface=nil
   num=0
   cnorm=face.normal
   cplane=face.plane
   zpt=Geom::Point3d.new 0,0,0
   ept=zpt.project_to_plane cplane
   tnorm=Geom::Vector3d.new ept.x,ept.y,ept.z #get true normal vector
  
   faceent.each do |ent|
    if (cnorm.parallel?(ent.normal))  
     eplane=ent.plane
     enept=zpt.project_to_plane eplane
     enorm=Geom::Vector3d.new enept.x,enept.y,enept.z #get true normal vector
     dnorm=enorm-tnorm                                #get difference vector
     dd=dnorm.length.abs
     if dd>dist
      dist=dd
      pface=ent
     end
     num=num+1
    end
   end
   if !(num==2) then pface=nil;dist=0 end   #only 2 parallel faces make sense
   return pface,dist
  end
 
  
  #reset to start over again
  def reset(view)
   @status=1
   @drawn=false
   @entity=nil
   Sketchup::set_status_text "Select component",SB_PROMPT
  end

 end #end class ResizeBoard*************************************************************

 #function acts as short cut for selecting tool
 def resizeboard
   Sketchup.active_model.select_tool ResizeBoard.new 
 end
 
 if( not file_loaded?("ResizeBoard.rb"))
  UI.menu("Draw").add_item("Resize Board"){resizeboard}
 end

 file_loaded("ResizeBoard.rb")
 